%ITSOLVE_STOKES specialized iterative solution of Stokes problem
%optional preset parameters
%         apost        1/0 error estimation on/off  
%         stopit       1/0 stopping test on/off
% for further details see
%  "David J. Silvester and Valeria Simoncini",
%  "An Optimal Iterative Solver for Symmetric Indefinite
%         Systems stemming from Mixed Approximation",
% "{ACM} Transactions on Mathematical Software, 37, 2010."
% "http://eprints.ma.man.ac.uk/1450/"

%IFISS scriptfile: DJS; 21 January 2011. 
% Copyright (c) 2011 D.J. Silvester, V. Simoncini

% Declare global variables for scalar AMG preconditioner
global amg_grid amg_smoother number_vcycles
%
prob_type='stokes'; apost = 0; stopit = 1; Mest = ''; eparams = {};
tol=1e-6; maxit=99;         %% fixed termination parameters
% set default options if not preset
if exist('apost','var')==0,
   apost=1;  stopit=1;       %% enforce dynamic stopping test
end   
%
% specify coefficient matrix
if qmethod<=1, stabC = beta*C;
%       error('stabilized approximation is not implemented yet')
else,  stabC = sparse(np,np); end
%
% AMG velocity preconditioner
if achoice == 1
   load AMGparams
else 
   MA = 'm_fulla'; aparams = struct('A',Ast); 
end
% select pressure preconditioner and construct it
%qchoice = default('mass matrix approximation: Chebyshev (1) or diagonal (2)? (default 1)',1);
%if qmethod==2;
if qchoice==1
%   MQ='m_masscheb';qparams = struct('Q',Q,'its',number_its,'qmethod',-qmethod);
elseif qchoice==2
%    alpha = default('scaling parameter alpha in preconditioner? (default 1)',1);
    MQ='m_massdiag';qparams = struct('Q',Q,'qmethod',qmethod,'alpha',alpha);
elseif qchoice==3;
   MQ='m_massfull';qparams = struct('Q',Q,'qmethod',qmethod,'alpha',alpha);
end 
%

   if qmethod==3;
   if domain == 3 || domain == 10 || domain==4,  % step, channel, obstacle
%       fprintf('Natural outflow on right boundary ..\n')
      neumannb=out_Neumann_bound(mv,xy);
   else,  neumannb=[];
   end
  [hx,hy,eex] = eexgen(xy,xyp,mv,ee); % check element numbering
  [error_x,error_y,fex,fey,ae]= ...
                      stokespost_q2p1(xy,mv,mbound,neumannb,[fst;gst],eex,hx,hy);
   %% returns LDLT factorised element matrices ae
   Mest='est_errorq2p1'; 
   eparams = struct('ae',ae,'xy',xy,'mv',mv,'mbound',mbound, ...
                   'neumannb',neumannb,'eex',eex,'hx',hx,'hy',hy);
   else, apost = 0; end
%   else, error('Dynamic estimation not yet implemented!'), end
   [xest,resvec,infsup,errpde,info] = ...
       est_minres_scaled(Ast,Bst',stabC,fst,gst,apost,stopit,maxit,tol, ...
                  prob_type,MA,aparams,MQ,qparams,Mest,eparams);


